//
//  BarCodePrintViewController.m
//  SHC
//
//  Created by Ambiga on 18/05/15.
//  Copyright (c) 2015 Ambiga. All rights reserved.
//

#import "BarCodePrintViewController.h"
#define TREBUCHET_MS @"Trebuchet MS"
#define NUMBERS_ONLY 0123456789


@interface BarCodePrintViewController ()
{
     UIScrollView * scrollview;
    
    NSMutableArray * mArrayXs;
    NSMutableArray * mArrayYs;
    NSArray * mArrayType;
    NSArray * mArrayHRI;
    NSArray * mArrayFont;
    
    int nSelectedType;
    int nSelectedHRI;
    int nSelectedFont;
    NSString * nSelectedWidth;
    NSString * nSelectedHeight;
    
    //UI to show and hide number pad for text fields
    UIToolbar *toolBar;
    UIBarButtonItem *barItemHideNumPad, *barItemClearText;
}
@end

@implementation BarCodePrintViewController

@synthesize printer;

- (void)loadView{
    [super loadView];
    if ([self respondsToSelector:@selector(edgesForExtendedLayout)]) {
        self.edgesForExtendedLayout = UIRectEdgeNone;
        self.extendedLayoutIncludesOpaqueBars = NO;
        self.automaticallyAdjustsScrollViewInsets = NO;
    }
    self.navigationController.toolbarHidden = YES ;
    
    scrollview=[[UIScrollView alloc]initWithFrame:self.view.bounds];;
    scrollview.showsVerticalScrollIndicator=YES;
    [scrollview setBackgroundColor:[UIColor whiteColor]];
    scrollview.scrollEnabled=YES;
    scrollview.userInteractionEnabled=YES;
    CGSize scrollViewContentSize = CGSizeMake(320,900);
    [scrollview setContentSize:scrollViewContentSize];
    [scrollview setDelegate:self];
    [self.view addSubview:scrollview];
    UILabel *printCharacters = [[UILabel alloc]initWithFrame:CGRectMake(self.view.frame.origin.x + 20, self.view.frame.origin.y + 5, 200,30)];
    [printCharacters setText:@"Data"];
    [printCharacters setTextAlignment: NSTextAlignmentLeft];
    [printCharacters setBackgroundColor:[UIColor clearColor]];
    [printCharacters setTextColor: [UIColor blackColor]];
//    if([[UIDevice currentDevice].model containsString:@"iPhone"])
    if([UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPhone)

        [printCharacters setFont:[UIFont fontWithName: @"Trebuchet MS" size: 18]];
    else
        [printCharacters setFont:[UIFont fontWithName: @"Trebuchet MS" size: 20]];
    [scrollview addSubview:printCharacters];
    //Textview to type the command
    commandText = [[UITextView alloc]initWithFrame:CGRectMake(self.view.frame.origin.x + 20, self.view.frame.origin.y + 5 + printCharacters.frame.size.height, self.view.frame.size.width - 40, self.view.frame.size.height/5)];
    commandText.layer.borderColor = [UIColor darkGrayColor].CGColor;
    commandText.layer.cornerRadius = 5;
    commandText.font = [UIFont systemFontOfSize:18];
    commandText.layer.borderWidth = 1;
    commandText.textColor = [UIColor blackColor];
    commandText.returnKeyType = UIReturnKeyDefault;
    commandText.keyboardType = UIKeyboardTypeDefault;
    [scrollview addSubview:commandText];
    
   
    commandTextArray = [NSArray arrayWithObjects:@"01234567890",@"01234500005",@"201234567890",@"201234567890",@"2012345",@"2012345",@"1234",@"012345",@"A012345A",@"ABCDE",@"{Babcde",nil];
   
    [commandText setText: [commandTextArray objectAtIndex:0]];

//    if([[UIDevice currentDevice].model containsString:@"iPhone"])
    if([UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPhone)
    {

        moduleSize = [[UILabel alloc]initWithFrame:CGRectMake(self.view.frame.origin.x + 20, commandText.frame.size.height + barcodeTypeLabel.frame.size.height + barcodeTypeLabel.frame.origin.y + 80, 100, 15)];
        printButton = [[UIButton alloc]initWithFrame: CGRectMake(((self.view.frame.size.width - (self.view.frame.size.width/2)) /2), scrollview.frame.origin.y + scrollview.frame.size.height + 40 , self.view.frame.size.width /2, 50)];    }
    else
    {

         moduleSize = [[UILabel alloc]initWithFrame:CGRectMake(self.view.frame.origin.x + 20, commandText.frame.size.height + barcodeTypeLabel.frame.size.height + barcodeTypeLabel.frame.origin.y - 10, 100, 15)];
         printButton = [[UIButton alloc]initWithFrame: CGRectMake(((self.view.frame.size.width - (self.view.frame.size.width/2)) /2), scrollview.frame.origin.y + scrollview.frame.size.height - 134 , self.view.frame.size.width /2, 50)];
    }
    
    [printButton setTitle:@"Print" forState:UIControlStateNormal];
    printButton.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
    printButton.backgroundColor = [UIColor colorWithRed:85.0/255.0 green:143.0/255.0 blue:220.0/255.0 alpha:1.0];
    [printButton addTarget:self action:@selector(sendCommandToPrinter) forControlEvents:UIControlEventTouchUpInside];
    [scrollview addSubview:printButton];
    
    
    commandText.delegate = self;
  
}


- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor groupTableViewBackgroundColor];
    [self updateBarcodeUI];

}
- (void) loadToolbar
{
    NSDictionary *attributes = [NSDictionary dictionaryWithObjectsAndKeys:
                                [UIFont fontWithName: TREBUCHET_MS size: 18], NSFontAttributeName,
                                [UIColor darkGrayColor], NSForegroundColorAttributeName,
                                nil];
    
    //toolbar
    UIBarButtonItem *barItemSpace = [[UIBarButtonItem alloc]
                                     initWithBarButtonSystemItem: UIBarButtonSystemItemFlexibleSpace
                                     target: nil
                                     action: nil];
    
    barItemHideNumPad = [[UIBarButtonItem alloc]
                         initWithTitle: @"Hide"
                         style: UIBarButtonItemStyleDone
                         target: self
                         action: nil];
    [barItemHideNumPad setTitleTextAttributes: attributes forState: UIControlStateNormal];
    
    barItemClearText = [[UIBarButtonItem alloc]
                        initWithTitle: @"Clear"
                        style: UIBarButtonItemStyleDone
                        target: self
                        action: nil];
    [barItemClearText setTitleTextAttributes: attributes forState: UIControlStateNormal];
    
    const float heightToolbar = 40.0f;
    toolBar = [[UIToolbar alloc] initWithFrame:
               CGRectMake(0, 0, self.view.frame.size.width, heightToolbar)];
    [toolBar setItems: [NSArray arrayWithObjects:
                        barItemHideNumPad,barItemSpace, barItemClearText, nil]];
}

-(void) updateBarcodeUI
{
    mArrayType = [NSArray arrayWithObjects:
                  @"UPC_A",@"UPC_E",@"EAN13",@"JAN13",
                  @"EAN8",@"JAN8",@"CODE_39",@"ITF",
                  @"CODABAR",@"CODE_93",@"CODE_128",nil];
    mArrayHRI = [NSArray arrayWithObjects:@"NONE", @"ABOVE", @"BELOW", @"BOTH",nil];
    
    mArrayFont = [NSArray arrayWithObjects:@"FONT_A",@"FONT_B",nil];
    mArrayXs = [[NSMutableArray alloc] init];
    mArrayYs = [[NSMutableArray alloc] init];
    
    for (int i = 2; i <= 6; i++)
    {
        [mArrayXs addObject:[NSString stringWithFormat:@"%d", i]];
    }
    
    for (int i = 1; i <= 255; i++)
    {
        [mArrayYs addObject:[NSString stringWithFormat:@"%d", i]];
    }
    
    CGRect rect = CGRectMake(self.view.frame.origin.x + 20, commandText.frame.origin.y + commandText.frame.size.height + 50, self.view.frame.size.width/3 - 25, 100);
    for (int i = 0; i <= 4; i++)
    {
        UIPickerView * pickerView =  [[UIPickerView alloc]initWithFrame:rect];
        pickerView.delegate = self;
        pickerView.dataSource = self;
        pickerView.tag = i;
        [pickerView.layer setBorderColor: [UIColor darkGrayColor].CGColor];
        [pickerView.layer setBorderWidth: 1.0f];
        [pickerView.layer setCornerRadius: 5.0f];
        [scrollview addSubview:pickerView];
        
        UILabel *label = [[UILabel alloc] initWithFrame: CGRectMake(pickerView.frame.origin.x, pickerView.frame.origin.y - 27, pickerView.frame.size.width, 22)];
        NSString * string = nil;
        switch (i) {
            case 0:
                string = @"Type";
                [pickerView selectRow:0 inComponent:0 animated:YES];
                nSelectedType = (int)[pickerView selectedRowInComponent:0];
                break;
            case 1:
                string = @"HRI";
                [pickerView selectRow:0 inComponent:0 animated:YES];
                nSelectedHRI = (int)[pickerView selectedRowInComponent:0];
                break;
            case 2:
                string = @"Font";
                [pickerView selectRow:0 inComponent:0 animated:YES];
                nSelectedFont = (int)[pickerView selectedRowInComponent:0];
                break;
            case 3:
                string = @"Width";
                [pickerView selectRow:1 inComponent:0 animated:YES];
                nSelectedWidth = [mArrayXs objectAtIndex:1];
                break;
            case 4:
                string = @"Height";
                [pickerView selectRow:161 inComponent:0 animated:YES];
                nSelectedHeight = [mArrayYs objectAtIndex:161];
                break;
                
            default:
                break;
        }
        
        [label setText:string];
//        if([[UIDevice currentDevice].model containsString:@"iPhone"])
        if([UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPhone)

            [label setFont:[UIFont fontWithName: @"Trebuchet MS" size: 18]];
        else
            [label setFont:[UIFont fontWithName: @"Trebuchet MS" size: 20]];        [label setTextAlignment: NSTextAlignmentCenter];
        [label setBackgroundColor:[UIColor clearColor]];
        [label setTextColor: [UIColor blackColor]];
        [scrollview addSubview:label];
        rect.origin.x += rect.size.width + 15;
        
        if(i == 2)
        {
            rect.origin.y += pickerView.frame.size.height + 50;
            rect.origin.x = self.view.frame.origin.x + 20;
        }
    }
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:YES];
    self.navigationController.toolbarHidden = YES ;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - UIScrollViewDelegate
- (void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    [self changeScrollBarColorFor:scrollView];
}

- (void)changeScrollBarColorFor:(UIScrollView *)scrollView
{
    for ( UIView *view in scrollView.subviews ) {
        
        if (view.tag == 0 && [view isKindOfClass:UIImageView.class])
        {
            
            UIImageView *imageView = (UIImageView *)view;
            imageView.backgroundColor = [UIColor colorWithRed:85.0/255.0 green:143.0/255.0 blue:220.0/255.0 alpha:1.0];
        }
    }
}

#pragma mark - Text View View Delegates
- (BOOL) textViewShouldBeginEditing:(UITextView *)textView
{
    if(commandText)
    {
        if(!toolBar)
        {
            [self loadToolbar];
        }
        
        [barItemHideNumPad setTarget: textView];
        [barItemHideNumPad setAction: @selector(resignFirstResponder)];
        
        [barItemClearText setTarget: self];
        [barItemClearText setAction:@selector(clearText)];
        
        [textView setInputAccessoryView: toolBar];
    }
    
    return YES;
}

- (void) clearText
{
    commandText.text = nil;
    
}

- (BOOL)textFieldShouldEndEditing:(UITextField *)textField
{
    return YES;
}
- (void)textViewDidBeginEditing:(UITextView *)textView
{
    //Implementation not required
}


- (void)textViewDidEndEditing:(UITextView *)textView{
    commandText.text = textView.text ;
}
- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    [self.view endEditing:YES];
    [scrollview endEditing:YES];
    [super touchesBegan:touches withEvent:event];
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range
 replacementText:(NSString *)text
{
   
    // Any new character added is passed in as the "text" parameter
    if ([text isEqualToString:@"\n"]) {
        // Be sure to test for equality using the "isEqualToString" message
        // [textView resignFirstResponder];
//        commandText.text = [NSString stringWithFormat:@"%@\n",commandText.text];
        [commandText insertText:text];
        // Return FALSE so that the final '\n' character doesn't get added
        return FALSE;
    }
    // For any other character return TRUE so that the text gets added to the view
    return TRUE;
}

#pragma mark - Picker View Delegates
//PickerView delegate
- (UIView*) pickerView: (UIPickerView*)pickerView viewForRow: (NSInteger)row forComponent: (NSInteger)component reusingView: (UIView*)view
{
    NSString *pickerText = nil;
    
    switch (pickerView.tag)
    {
        case 0:
            pickerText = [mArrayType objectAtIndex:row];
            break;
            
        case 1:
            pickerText = [mArrayHRI objectAtIndex:row];
            break;
            
        case 2:
            pickerText = [mArrayFont objectAtIndex:row];
            break;
            
        case 3:
            pickerText = [mArrayXs objectAtIndex:row];
            break;
            
        case 4:
            pickerText = [mArrayYs objectAtIndex:row];
            break;
            
        default:
            break;
    }
    
    UILabel *label = [[UILabel alloc] initWithFrame: CGRectMake(0, 0, widthPicker, 40)];
    [label setText: pickerText];
    [label setFont: fontPickerText];
    [label setTextAlignment: NSTextAlignmentCenter];
    [label setTextColor: [UIColor blackColor]];
    
    return  label;
    
}


- (NSInteger) pickerView: (UIPickerView*)pickerView numberOfRowsInComponent: (NSInteger)component
{
    NSInteger numRows = 0;
    
    switch (pickerView.tag)
    {
        case 0:
            numRows = [mArrayType count];
            break;
            
        case 1:
            numRows = [mArrayHRI count];
            break;
            
        case 2:
            numRows = [mArrayFont count];
            break;
            
        case 3:
            numRows = [mArrayXs count];
            break;
            
        case 4:
            numRows = [mArrayYs count];
            break;
            
        default:
            break;
    }    return numRows;
    
}


- (NSInteger) numberOfComponentsInPickerView: (UIPickerView *)pickerView
{
    return 1;
}

- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component
{
       if(pickerView.tag == 0){
        if([pickerView selectedRowInComponent: 0] == UPC_A){
//            [commandText resignFirstResponder];
//            commandText.keyboardType = UIKeyboardTypeNumberPad;
//            [commandText becomeFirstResponder];
            [commandText setText: [commandTextArray objectAtIndex:row]];
        }else if([pickerView selectedRowInComponent: 0] == UPC_E){
//            [commandText resignFirstResponder];
//            commandText.keyboardType = UIKeyboardTypeNumberPad;
//            [commandText becomeFirstResponder];
            [commandText setText: [commandTextArray objectAtIndex:row]];
        }else if([pickerView selectedRowInComponent: 0] == EAN13){
//            [commandText resignFirstResponder];
//            commandText.keyboardType = UIKeyboardTypeNumberPad;
//            [commandText becomeFirstResponder];
            [commandText setText: [commandTextArray objectAtIndex:row]];
        }else if([pickerView selectedRowInComponent: 0] == JAN13){
//            [commandText resignFirstResponder];
//            commandText.keyboardType = UIKeyboardTypeNumberPad;
//            [commandText becomeFirstResponder];
            [commandText setText: [commandTextArray objectAtIndex:row]];
        }else if([pickerView selectedRowInComponent: 0] == EAN8){
//            [commandText resignFirstResponder];
//            commandText.keyboardType = UIKeyboardTypeNumberPad;
//            [commandText becomeFirstResponder];
            [commandText setText: [commandTextArray objectAtIndex:row]];
        }else if([pickerView selectedRowInComponent: 0] == JAN8){
//            [commandText resignFirstResponder];
//            commandText.keyboardType = UIKeyboardTypeNumberPad;
//            [commandText becomeFirstResponder];
            [commandText setText: [commandTextArray objectAtIndex:row]];
        }else if([pickerView selectedRowInComponent: 0] == CODE_39){
//            [commandText resignFirstResponder];
//            commandText.keyboardType = UIKeyboardTypeAlphabet;
//            [commandText becomeFirstResponder];
            [commandText setText: [commandTextArray objectAtIndex:row]];
        }else if([pickerView selectedRowInComponent: 0] == ITF){
//            [commandText resignFirstResponder];
//            commandText.keyboardType = UIKeyboardTypeNumberPad;
//            [commandText becomeFirstResponder];
            [commandText setText: [commandTextArray objectAtIndex:row]];
        }else if([pickerView selectedRowInComponent: 0] == CODABAR){
//            [commandText resignFirstResponder];
//            commandText.keyboardType = UIKeyboardTypeAlphabet;
//            [commandText becomeFirstResponder];
            [commandText setText: [commandTextArray objectAtIndex:row]];
        }else if([pickerView selectedRowInComponent: 0] == CODE_93){
//            [commandText resignFirstResponder];
//            commandText.keyboardType = UIKeyboardTypeAlphabet;
//            [commandText becomeFirstResponder];
            [commandText setText: [commandTextArray objectAtIndex:row]];
        }else if([pickerView selectedRowInComponent: 0] == CODE_128){
//            [commandText resignFirstResponder];
//            commandText.keyboardType = UIKeyboardTypeAlphabet;
//            [commandText becomeFirstResponder];
            [commandText setText: [commandTextArray objectAtIndex:row]];
        }
    }
    switch (pickerView.tag)
    {
        case 0:
            nSelectedType = (int)[pickerView selectedRowInComponent:0];
            break;
            
        case 1:
            nSelectedHRI = (int)[pickerView selectedRowInComponent:0];
            break;
            
        case 2:
            nSelectedFont = (int)[pickerView selectedRowInComponent:0];
            break;
            
        case 3:
            nSelectedWidth = [mArrayXs objectAtIndex:row];
            break;
            
        case 4:
            nSelectedHeight = [mArrayYs objectAtIndex:row];
            break;
            
        default:
            break;
    }

}
- (BOOL) isNumeric : (NSString *)string
{
    NSCharacterSet *cs = [[NSCharacterSet characterSetWithCharactersInString:@"0123456789"] invertedSet];
    NSString *filteredstring  = [[string componentsSeparatedByCharactersInSet:cs] componentsJoinedByString:@""];
    return ([string isEqualToString:filteredstring]);

}
- (BOOL) isAlphaNumeric : (NSString *)string
{
    if(nSelectedType == CODE_128)
    {
        NSCharacterSet *cs = [[NSCharacterSet characterSetWithCharactersInString:@"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLKMNOPQRSTUVWXYZ0123456789!~`@#$%^&*-+();:={}[],.<>?\\/\"\'"] invertedSet];
        NSString *filteredstring  = [[string componentsSeparatedByCharactersInSet:cs] componentsJoinedByString:@""];
         return ([string isEqualToString:filteredstring]);
    }else{
    NSCharacterSet *unwantedCharacters =
    [[NSCharacterSet alphanumericCharacterSet] invertedSet];
    return ([string rangeOfCharacterFromSet:unwantedCharacters].location == NSNotFound) ? YES : NO;
    }
}
- (void)sendCommandToPrinter{
    
    if(printer){
        if(commandText.text.length > 0){
        SAM4SPrintIO *sam4sIO = (SAM4SPrintIO *)printer.printIO;
        printer.printIO.connection.delegate = self;
        
        [sam4sIO PrinterSetup];
        [sam4sIO addBarcode:[commandText.text dataUsingEncoding:NSUTF8StringEncoding] :nSelectedType :nSelectedHRI :nSelectedFont :[nSelectedWidth intValue] :[nSelectedHeight intValue]];
        NSInteger length = commandText.text.length;
       
        if((nSelectedType == UPC_A || nSelectedType == UPC_E) && (length == 12 || length == 11) && [self isNumeric:commandText.text])
        {
            [printer.printIO.connection sendDataToPrinter:[sam4sIO getDataTosend:sam4sIO]];
 
        }else if((nSelectedType == EAN13 ||nSelectedType == JAN13)  && (length == 12 || length == 13)&& [self isNumeric:commandText.text])
        {
            [printer.printIO.connection sendDataToPrinter:[sam4sIO getDataTosend:sam4sIO]];
            
        }else if((nSelectedType == EAN8 ||nSelectedType == JAN8)  && (length == 7 || length == 8)&& [self isNumeric:commandText.text])
        {
            [printer.printIO.connection sendDataToPrinter:[sam4sIO getDataTosend:sam4sIO]];
            
        }
        else if((nSelectedType == CODE_39  || nSelectedType == CODABAR ||nSelectedType == CODE_93)  && (length > 1) && [self isAlphaNumeric:commandText.text])
        {
            [printer.printIO.connection sendDataToPrinter:[sam4sIO getDataTosend:sam4sIO]];
            
        }
        else if ( nSelectedType == CODE_128 && (length > 1) && (length < 255 ) && [self isAlphaNumeric:commandText.text])
        {
            [printer.printIO.connection sendDataToPrinter:[sam4sIO getDataTosend:sam4sIO]];
        }
        else if(nSelectedType == ITF && (length % 2 == 0) && (length > 1) && (length < 255 ) && [self isNumeric:commandText.text])
        {
            [printer.printIO.connection sendDataToPrinter:[sam4sIO getDataTosend:sam4sIO]];

        }
        else{
            [self invalidData];
        }
        }else{
            
            UIAlertView * alert = [[UIAlertView alloc]
                                   initWithTitle: @"Error"
                                   message: @"No data"
                                   delegate: nil
                                   cancelButtonTitle: @"Dismiss" otherButtonTitles: nil];
            [alert show];
            
        }
       }
}
- (void)invalidData
{
    UIAlertView * alert = [[UIAlertView alloc]
                           initWithTitle: @"Error"
                           message: @"Invalid data"
                           delegate: nil
                           cancelButtonTitle: @"Dismiss" otherButtonTitles: nil];
    [alert show];
}
-(void) didReceivedDataFromPrinter:(NSData*)data
{
    NSLog(@"data = %@", [data description]);
}
@end
