//
//  ImagePrintViewController.m
//  SHC
//
//  Created by Ambiga on 18/05/15.
//  Copyright (c) 2015 Ambiga. All rights reserved.
//

#import "ImagePrintViewController.h"
#import <MobileCoreServices/MobileCoreServices.h>
#import <UIKit/UIKit.h>
//#define colorIntensity(R,G,B) ((R)*77L+(G)*152L+(B)*28L) 
//#define TAG_BUTTON_OFFSET 4567
#define VERTICAL_SPACING 60
//#define CV_TERMCRIT_ITER 1
//#ifdef __cplusplus
//#import <opencv2/opencv.hpp>
//#include <iostream>
//#import "opencv2/imgcodecs/ios.h"
//#endif

#define BMP_EXTENSION @".bmp"

@interface ImagePrintViewController ()
{
    NSData *_imageData ;
    UIImage *chosenImage;
    UIImage *newImage;
}
@end

@implementation ImagePrintViewController
@synthesize printer;

-(void)loadView{
    [super loadView];
    if ([self respondsToSelector:@selector(edgesForExtendedLayout)]) {
        self.edgesForExtendedLayout = UIRectEdgeNone;
        self.extendedLayoutIncludesOpaqueBars = NO;
        self.automaticallyAdjustsScrollViewInsets = NO;
    }
    self.navigationController.toolbarHidden = YES ;
    
    selectImageButton = [[UIButton alloc]initWithFrame:CGRectMake(((self.view.frame.size.width - (self.view.frame.size.width/2)) /2), self.view.frame.origin.y +30 , self.view.frame.size.width /2, 50)];
    [selectImageButton setTitle:@" Select Image " forState:UIControlStateNormal];
    selectImageButton.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
    selectImageButton.backgroundColor = [UIColor colorWithRed:85.0/255.0 green:143.0/255.0 blue:220.0/255.0 alpha:1.0];
    selectImageButton.center = CGPointMake(self.view.frame.size.width/2, self.view.frame.origin.y + 30);// for vertically center
    [selectImageButton addTarget:self action:@selector(selectPhoto:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:selectImageButton];
    

    imageView= [[UIImageView alloc]init];
    [self.view addSubview: imageView];
    imageView.center = self.view.center;
    imageView.contentMode = UIViewContentModeScaleAspectFit;
    
    printButton = [[UIButton alloc]initWithFrame: CGRectMake(((self.view.frame.size.width - (self.view.frame.size.width/2)) /2), self.view.frame.origin.y + self.view.frame.size.height - 134, self.view.frame.size.width /2, 50)];
    [printButton setTitle:@"Print" forState:UIControlStateNormal];
    printButton.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
    printButton.backgroundColor = [UIColor colorWithRed:85.0/255.0 green:143.0/255.0 blue:220.0/255.0 alpha:1.0];
    [printButton addTarget:self action:@selector(sendCommandToPrinter) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:printButton];
    [self.view setBackgroundColor:[UIColor whiteColor]];

}


- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor groupTableViewBackgroundColor];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:YES];
    self.navigationController.toolbarHidden = YES ;
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:YES];
    imageView.image = nil;
}

- (IBAction)selectPhoto:(UIButton *)sender {
    
    UIImagePickerController *picker = [[UIImagePickerController alloc] init];
    picker.delegate = self;
    picker.sourceType = UIImagePickerControllerSourceTypeSavedPhotosAlbum;
    [self presentViewController:picker animated:YES completion:NULL];

}

- (void) updateSelectedImage
{
    [printButton setHidden: NO];

     self.view.translatesAutoresizingMaskIntoConstraints = NO;
     imageView.translatesAutoresizingMaskIntoConstraints = NO;
    
//    UIImage *image = chosenImage;
    UIImage *image = [UIImage imageWithContentsOfFile:path];
    chosenImage = image;
    float heightImageView =	self.view.frame.size.height  -
    printButton.frame.size.height - VERTICAL_SPACING - selectImageButton.frame.origin.y + selectImageButton.frame.size.height  - 2 * VERTICAL_SPACING + 40;
    float wImage = 0, hImage = 0, sideMargin = 10;
    float wImageMax = self.view.frame.size.width - 2 * sideMargin;
    
    if(image.size.width > wImageMax)
    {
        wImage = wImageMax;
        hImage = (wImage * image.size.height) / image.size.width;
        
        if(hImage > heightImageView)
        {
            hImage = heightImageView;
            wImage = (hImage * image.size.width) / image.size.height;
        }
    }
    else if(image.size.height > heightImageView)
    {
        hImage = heightImageView ;
        wImage = (hImage * image.size.width) / image.size.height;
        
        if(wImage > wImageMax)
        {
            wImage = wImageMax;
            hImage = (wImage * image.size.height) / image.size.width ;
        }
    }
    else
    {
        wImage = image.size.width;
        hImage = image.size.height - 50;
    }
    
    float xImage = sideMargin + ((self.view.frame.size.width - 2 * sideMargin) - wImage) / 2;
    float yImage = VERTICAL_SPACING + (heightImageView - hImage) / 2 + 5;
    
    [imageView setFrame: CGRectMake(xImage, yImage, wImage, hImage)];
}
#pragma mark - Image Picker Controller delegate methods

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info
{
   chosenImage = info[UIImagePickerControllerOriginalImage];
    
   chosenImage= [self scaleAndRotateImage:chosenImage];
    [imageView setImage:chosenImage];
    NSData * data = UIImagePNGRepresentation(chosenImage);
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
    path = [documentsDirectory stringByAppendingPathComponent:[NSString stringWithFormat:@"%@.png",@"test"]];
    [data writeToFile:path atomically:YES];
    [self updateSelectedImage];
    [imageView setImage:chosenImage];
    [picker dismissViewControllerAnimated:YES completion:NULL];
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker
{
    [picker dismissViewControllerAnimated:YES completion:NULL];
    
}

- (void)sendCommandToPrinter
{
if(printer){
    SAM4SPrintIO *sam4sIO = (SAM4SPrintIO *)printer.printIO;
    printer.printIO.connection.delegate = self;
//    chosenImage = [self ditherImage:chosenImage];
    if(imageView.image)
    {
    //chosenImage is the image selected from gallery
    [sam4sIO PrinterSetup];
    [sam4sIO addImageData: imageView.image imageWidth: imageView.image.size.width imageHeight: imageView.image.size.height imageMode:NORMAL];
    [printer.printIO.connection sendDataToPrinter:[sam4sIO getDataTosend:sam4sIO]];
    }
    else
    {
       UIAlertView * alert = [[UIAlertView alloc]
                 initWithTitle: @"Invalid"
                 message: @"Select the image to Print"
                 delegate: nil
                 cancelButtonTitle: @"OK" otherButtonTitles: nil];
        [alert show];
 
    }
  }
}

-(void) didReceivedDataFromPrinter:(NSData*)data
{
    NSLog(@"data = %@", [data description]);
}

- (UIImage *)scaleAndRotateImage:(UIImage *)image {
    
    int kMaxResolution = 1024; // Or whatever
    
    CGImageRef imgRef = image.CGImage;
    
    CGFloat width = CGImageGetWidth(imgRef);
    CGFloat height = CGImageGetHeight(imgRef);
    
    
    CGAffineTransform transform = CGAffineTransformIdentity;
    CGRect bounds = CGRectMake(0, 0, width, height);
    if (width > kMaxResolution || height > kMaxResolution) {
        CGFloat ratio = width/height;
        if (ratio > 1) {
            bounds.size.width = kMaxResolution;
            bounds.size.height = roundf(bounds.size.width / ratio);
        }
        else {
            bounds.size.height = kMaxResolution;
            bounds.size.width = roundf(bounds.size.height * ratio);
        }
    }
    
    CGFloat scaleRatio = bounds.size.width / width;
    CGSize imageSize = CGSizeMake(CGImageGetWidth(imgRef), CGImageGetHeight(imgRef));
    CGFloat boundHeight;
    UIImageOrientation orient = image.imageOrientation;
    switch(orient) {
            
        case UIImageOrientationUp: //EXIF = 1
            transform = CGAffineTransformIdentity;
            break;
            
        case UIImageOrientationUpMirrored: //EXIF = 2
            transform = CGAffineTransformMakeTranslation(imageSize.width, 0.0);
            transform = CGAffineTransformScale(transform, -1.0, 1.0);
            break;
            
        case UIImageOrientationDown: //EXIF = 3
            transform = CGAffineTransformMakeTranslation(imageSize.width, imageSize.height);
            transform = CGAffineTransformRotate(transform, M_PI);
            break;
            
        case UIImageOrientationDownMirrored: //EXIF = 4
            transform = CGAffineTransformMakeTranslation(0.0, imageSize.height);
            transform = CGAffineTransformScale(transform, 1.0, -1.0);
            break;
            
        case UIImageOrientationLeftMirrored: //EXIF = 5
            boundHeight = bounds.size.height;
            bounds.size.height = bounds.size.width;
            bounds.size.width = boundHeight;
            transform = CGAffineTransformMakeTranslation(imageSize.height, imageSize.width);
            transform = CGAffineTransformScale(transform, -1.0, 1.0);
            transform = CGAffineTransformRotate(transform, 3.0 * M_PI / 2.0);
            break;
            
        case UIImageOrientationLeft: //EXIF = 6
            boundHeight = bounds.size.height;
            bounds.size.height = bounds.size.width;
            bounds.size.width = boundHeight;
            transform = CGAffineTransformMakeTranslation(0.0, imageSize.width);
            transform = CGAffineTransformRotate(transform, 3.0 * M_PI / 2.0);
            break;
            
        case UIImageOrientationRightMirrored: //EXIF = 7
            boundHeight = bounds.size.height;
            bounds.size.height = bounds.size.width;
            bounds.size.width = boundHeight;
            transform = CGAffineTransformMakeScale(-1.0, 1.0);
            transform = CGAffineTransformRotate(transform, M_PI / 2.0);
            break;
            
        case UIImageOrientationRight: //EXIF = 8
            boundHeight = bounds.size.height;
            bounds.size.height = bounds.size.width;
            bounds.size.width = boundHeight;
            transform = CGAffineTransformMakeTranslation(imageSize.height, 0.0);
            transform = CGAffineTransformRotate(transform, M_PI / 2.0);
            break;
            
        default:
            [NSException raise:NSInternalInconsistencyException format:@"Invalid image orientation"];
            
    }
    
    UIGraphicsBeginImageContext(bounds.size);
    
    CGContextRef context = UIGraphicsGetCurrentContext();
    
    if (orient == UIImageOrientationRight || orient == UIImageOrientationLeft) {
        CGContextScaleCTM(context, -scaleRatio, scaleRatio);
        CGContextTranslateCTM(context, -height, 0);
    }
    else {
        CGContextScaleCTM(context, scaleRatio, -scaleRatio);
        CGContextTranslateCTM(context, 0, -height);
    }
    
    CGContextConcatCTM(context, transform);
    
    CGContextDrawImage(UIGraphicsGetCurrentContext(), CGRectMake(0, 0, width, height), imgRef);
    UIImage *imageCopy = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    return imageCopy;
}
/*
#pragma mark - Steinburg algorothm
-(UIImage*)ditherImage:(UIImage*)image
{
    int nrColors = 2;
    cv::Mat img;
    UIImageToMat(image, img);
    //cv::Mat img;
    //cvtColor(imgBGR, img, cv::COLOR_BGR2Lab);
    cv::Mat colVec = img.reshape(1, img.rows*img.cols); // change to a Nx3 column vector
    
    cv::Mat colVecD;
    colVec.convertTo(colVecD, CV_32FC4, 1.0); // convert to floating point
    
    cv::Mat labels, centers;
    cv::kmeans(colVecD, nrColors, labels,
               cv::TermCriteria(CV_TERMCRIT_ITER, 100, 0.1),
               4, cv::KMEANS_PP_CENTERS, centers); // compute k mean centers
    
    // replace pixels by there corresponding image centers
    
    
    cv::Mat imgPosterized = img.clone();
    for(int i = 0; i < img.rows; i++ )
    {
        for(int j = 0; j < img.cols; j++ )
        {
            for(int k = 0; k < 4; k++)
            {
                imgPosterized.at<cv::Vec4b>(i,j)[k] = centers.at<float>(labels.at<int>(j+img.cols*i),k);
            }
        }
    }
    
    // convert palette back to uchar
    cv::Mat palette;
    centers.convertTo(palette,CV_8UC4,1.0);
    
    
    
    img= floydSteinberg(img,palette);
    
    
    cv::Mat imgGray;
    cvtColor(img, imgGray,cv::COLOR_RGB2GRAY);
    image= MatToUIImage(imgGray);
    return image;
}

cv::Mat floydSteinberg(cv::Mat imgOrig, cv::Mat palette)
{
    cv::Mat img = imgOrig.clone();
    cv::Mat resImg = img.clone();
    
    int multiplier=255;
    for(int i = 0; i < img.rows; i++ )
    {
        for(int j = 0; j < img.cols; j++ )
        {
            cv::Vec4b newpixel = findClosestPaletteColor(img.at<cv::Vec4b>(i,j), palette);
            resImg.at<cv::Vec4b>(i,j) = newpixel;
            
            for(int k=0;k<4;k++)
            {
                int quant_error = (int)img.at<cv::Vec4b>(i,j)[k] - newpixel[k];
                if(j+1<img.cols)
                    img.at<cv::Vec4b>(i,j+1)[k] = fmin(255,fmax(0,(int)img.at<cv::Vec4b>(i,j+1)[k] + (7 * quant_error*multiplier) / 4096));
                if(i+1 < img.rows && j-1 >= 0)
                    img.at<cv::Vec4b>(i+1,j-1)[k] = fmin(255,fmax(0,(int)img.at<cv::Vec4b>(i+1,j-1)[k] + (3 * quant_error*multiplier) / 4096));
                if(i+1 < img.rows)
                    img.at<cv::Vec4b>(i+1,j)[k] = fmin(255,fmax(0,(int)img.at<cv::Vec4b>(i+1,j)[k] + (5 * quant_error*multiplier) / 4096));
                if(i+1 < img.rows && j+1 < img.cols)
                    img.at<cv::Vec4b>(i+1,j+1)[k] = fmin(255,fmax(0,(int)img.at<cv::Vec4b>(i+1,j+1)[k] + (1 * quant_error*multiplier) / 4096));
            }
        }
    }
    return resImg;
}

float vec3bDist(cv::Vec4b a, cv::Vec4b b)
{
    return sqrt( pow((float)a[0]-b[0],2) + pow((float)a[1]-b[1],2) + pow((float)a[2]-b[2],2) );
}

cv::Vec4b findClosestPaletteColor(cv::Vec4b color, cv::Mat palette)
{
    int i=0;
    int minI = 0;
    cv::Vec4b diff = color - palette.at<cv::Vec4b>(0);
    float minDistance = vec3bDist(color, palette.at<cv::Vec4b>(0));
    for (int i=0;i<palette.rows;i++)
    {
        float distance = vec3bDist(color, palette.at<cv::Vec4b>(i));
        if (distance < minDistance)
        {
            minDistance = distance;
            minI = i;
        }
    }
    return palette.at<cv::Vec4b>(minI);
}
*/
@end
