//
//  PrinterListViewController.h
//  SDK Sample
//
//  Created by Ambiga on 08/09/15.
//  Copyright (c) 2015 Ambiga. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ConnectionManager.h"
#import "PrinterConnection.h"
#import "PrinterTableViewCell.h"
#import "WiredConnectionManager.h"
#import "BTConnectionManager.h"
#import <ExternalAccessory/ExternalAccessory.h>
#import "MBProgressHUD.h"

@class WiredConnectionManager;
@class BTConnectionManager;
@class ConnectionManager;

@interface PrinterListViewController : UIViewController <ConnectionManagerDelegate,ConnectionPrinterDelegate, UITextFieldDelegate,UIAlertViewDelegate, UIGestureRecognizerDelegate,UITableViewDataSource, UITableViewDelegate, EAAccessoryDelegate, MBProgressHUDDelegate, WiredConnectionUDPDelegate>
{
    BTConnectionManager *bluetoothManager;
    EAAccessory *selectedAccessory;
    Printer *connectedPrinter;
    NSMutableArray *printerListArray;
    WiredConnectionManager * wiredManager;
    NSString *selectedIPAddr;//used to get the Selected Ip from cell
    UISegmentedControl *segmentedControl;
    BOOL isBluetooth;
    BOOL isEthernet;
    UIView *addToolbarView;
    UITextField *ipAddressTextField;
    
    UINavigationController *navControllerForSamplePrint;
    UIBarButtonItem *refreshButton;
    
    NSString * resultText;
    
}
@property NSArray * availablePrintersArray;
@property (strong,nonatomic) UITableView *tableView;
@property (strong,nonatomic) Printer *connectedPrinter;

@property BOOL connectedIP;
- (Printer*)getConnectedPrinter;
- (BTConnectionManager*) getConnectionForBluetooth;
- (NSArray *)availablePrinters;
- (void)_accessoryDidDisconnect:(NSNotification *)notification;
@end
