//
//  PrinterTableViewCell.m
//  SHC
//
//  Created by Ambiga on 14/05/15.
//  Copyright (c) 2015 Ambiga. All rights reserved.
//

#import "PrinterTableViewCell.h"

#define FONT_TREBUCHET_MS @"Trebuchet MS"
#define CELL_MARGIN_LEFT 10
#define ICON_SIZE 24
#define HEIGHT_LABEL 30


@implementation PrinterTableViewCell

@synthesize  label, iconView;

#pragma mark - Set printer name & icon

- (void) setIcon: (NSString*) iconName
{
    if(!iconView)
    {
        iconView = [[UIImageView alloc] initWithFrame:
                    CGRectMake(CELL_MARGIN_LEFT, (self.frame.size.height - ICON_SIZE) / 2,
                               ICON_SIZE, ICON_SIZE)];
        [self.contentView addSubview: iconView];
    }
    
    [iconView setImage: [UIImage imageNamed: iconName]];
}


- (void) setPrinterName: (NSString*) printerName
{
    //label
    if(!label)//remove current label
    {
        label = [[UILabel alloc] initWithFrame:
                 CGRectMake(CELL_MARGIN_LEFT + ICON_SIZE + 20,
                            (self.frame.size.height - HEIGHT_LABEL) / 2,
                            self.contentView.frame.size.width, HEIGHT_LABEL)];
        [label setFont: [UIFont fontWithName: FONT_TREBUCHET_MS size: 17]];
        [label setNumberOfLines: 1];
        [label setTextColor: [UIColor darkGrayColor]];
        [self.contentView addSubview: label];
    }
    
    [label setText: printerName];
}


#pragma mark - Reset cell
- (void) resetCell
{
    [label setText: @""];
}


@end

