//
//  SamplePrintViewController.m
//  SHC
//
//  Created by Ambiga on 15/05/15.
//  Copyright (c) 2015 Ambiga. All rights reserved.
//

#import "SamplePrintViewController.h"
#import "PrinterTableViewCell.h"
#import "SAM4SPrintIO.h"
#import "Printer.h"
#import "SimplePingHelper.h"
#import "SimplePing.h"

#define COMMAND_BEEP @"1E"
#define COMMAND_INFO @"1A"
#define COMMAND_NAME @"1D4943"
#define COMMANAD_CUT @"as"


@interface SamplePrintViewController ()
{
    SAM4SPrintIO *posPrinter;
    UILabel *printerName ;
    
    //    UIAlertView *alert;
    //    NSMutableString *receivedDataString;
}
@end

@implementation SamplePrintViewController

@synthesize printer, printerIPAddress;

- (id)initWithStyle:(UITableViewStyle)style{
    self = [super initWithStyle:UITableViewStyleGrouped];
    
    if(self)
    {
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(disconnectionHandler) name:SAM4SPrinterConnectionLostNotification object:nil];
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(disconnectionHandler) name:EAAccessoryDidDisconnectNotification object:nil];
        wiredManager = [ConnectionManager sharedConnectionWithType:ConnectionTypeWiFi delegate:self];
        bluetoothManager = [ConnectionManager sharedConnectionWithType:ConnectionTypeBlueTooth delegate:self];
        
        printMenuArray = [NSArray arrayWithObjects:
                          @"Text Print",
                          @"Image Print",
                          @"Barcode Print",
                          @"2D Code Print",
                          @"Print Page Mode",
                          @"Print Status",
                          nil];
        printMenuImagesArray = [NSArray arrayWithObjects:
                                @"PrintMenu Text.png",
                                @"PrintMenu Image.png",
                                @"PrintMenu Barcode.png",
                                @"PrintMenu QRCode.png",
                                @"PrintMenu Receipt.png",
                                @"PrinterStatus.png",
                                nil];
        viewControllerClass = [NSArray arrayWithObjects:
                               @"TextPrintViewController",
                               @"ImagePrintViewController",
                               @"BarCodePrintViewController",
                               @"TwoDCodeViewController",
                               @"PageModeViewController",
                               @"StatusViewController",
                               nil];
        
        arrViewControllers = [[NSMutableArray alloc] init];
        printerInfo = [[NSMutableDictionary alloc]init];
        printerInfoArray = [[NSMutableArray alloc]init];
        
        //initialize all array elements to NSNull instance
        for(NSUInteger i = 0, i_max = [viewControllerClass count]; i < i_max; i++)
        {
            [arrViewControllers insertObject: [NSNull null] atIndex: i];
        }
        
        
    }
    
    return self;
    
}


- (void) loadView
{
    [super loadView];
    printerListViewController =[self.navigationController.viewControllers objectAtIndex:0];//[[PrinterListViewController alloc]init];
    [self.navigationItem setHidesBackButton:YES];
    self.navigationController.toolbarHidden = NO;
    
    UIBarButtonItem * backToMenuButton1 = [[UIBarButtonItem alloc] initWithTitle:@"Disconnect" style:UIBarButtonItemStylePlain target:self action:@selector(gobackHomeToScreen)];
    self.navigationItem.rightBarButtonItem = backToMenuButton1;
    //self.tableView.scrollEnabled = NO;
    
    [self.navigationController.toolbar setFrame:CGRectMake(0, self.navigationController.toolbar.frame.origin.y,  self.navigationController.toolbar.frame.size.width, 100)];
    
    posPrinter = [[SAM4SPrintIO alloc]init];
}


- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    CGSize statusBarSize = [[UIApplication sharedApplication] statusBarFrame].size;
    CGFloat h=MIN(statusBarSize.width, statusBarSize.height);
    UIEdgeInsets e = UIEdgeInsetsMake(self.navigationController.navigationBar.bounds.size.height - h + 6,
                                      0.0f,
                                      0.0f,
                                      0.0f);
    
    self.tableView.contentInset = e;
    
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:YES];
    isInfo = NO;
    isName = NO;
    
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:YES];
    [[self.navigationController.view viewWithTag:20002]removeFromSuperview];
    
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:YES];
    [self.navigationItem setHidesBackButton:YES];
    
    UIView *iv = [[UIView alloc] initWithFrame:CGRectMake(0,0,100,70)];
    UILabel *lblTitle = [[UILabel alloc]initWithFrame:CGRectMake(0,10,70,25)];
    lblTitle.text = @"Printer Menu";
    lblTitle.textColor = [UIColor whiteColor];
    [lblTitle sizeToFit];
    [iv addSubview:lblTitle];
    
    printerName = [[UILabel alloc]initWithFrame:CGRectMake(0,30,70,25)];
    if(printer.bluetoothAccessory.connected)
        printerName.text =[NSString stringWithFormat:@"%@",printer.bluetoothAccessory.name];
    else if (printer.iPAddress)
        printerName.text =[NSString stringWithFormat:@"%@",printer.iPAddress];
    printerName.textColor = [UIColor whiteColor];
    [printerName sizeToFit];
    [iv addSubview:printerName];
    [self.navigationController.navigationBar setTitleTextAttributes:[NSDictionary dictionaryWithObject:[UIColor whiteColor] forKey:NSForegroundColorAttributeName]];
    [self.navigationController.navigationBar setTintColor:[UIColor whiteColor]];
    self.navigationItem.titleView = iv;
    [self.navigationItem setHidesBackButton:YES];
    self.navigationController.toolbarHidden = YES;
    buttonView = [[UIView alloc]initWithFrame:CGRectMake(0, self.navigationController.view.frame.size.height-75, self.navigationController.view.frame.size.width, 75)];
    buttonView.backgroundColor = [UIColor whiteColor];
    buttonView.tag = 20002;
    if([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPad)
    {
        infoButton = [[UIButton alloc]initWithFrame:CGRectMake(self.navigationController.view.frame.origin.x + 0, 0, 50, 50)];
        infoButton.center =  CGPointMake(infoButton.frame.origin.x + 90, 44);// for vertically center
    }else if([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        infoButton = [[UIButton alloc]initWithFrame:CGRectMake(self.navigationController.view.frame.origin.x + 10 , 0, 50, 50)];
        infoButton.center =  CGPointMake(infoButton.frame.origin.x + 34, 44);// for vertically center
    }
    //    if([[UIDevice currentDevice].model containsString:@"iPhone"])
    //    {
    //
    //        infoButton = [[UIButton alloc]initWithFrame:CGRectMake(self.navigationController.view.frame.origin.x + 10 , 0, 50, 50)];
    //        infoButton.center =  CGPointMake(infoButton.frame.origin.x + 34, 44);// for vertically center
    //
    //    }else if([[UIDevice currentDevice].model containsString:@"iPad"])
    //    {
    //        infoButton = [[UIButton alloc]initWithFrame:CGRectMake(self.navigationController.view.frame.origin.x + 0, 0, 50, 50)];
    //        infoButton.center =  CGPointMake(infoButton.frame.origin.x + 90, 44);// for vertically center
    //
    //
    //    }
    [infoButton setImage:[UIImage imageNamed:@"Info.png"] forState:UIControlStateNormal];
    [infoButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    [infoButton addTarget:self action:@selector(info_Button_Action) forControlEvents:UIControlEventTouchUpInside];
    [buttonView addSubview:infoButton];
    
    
    nameButton = [[UIButton alloc]initWithFrame:CGRectMake(self.navigationController.view.frame.size.width/4 + 10, 0, 50, 50)];
    [nameButton setImage:[UIImage imageNamed:@"PrinterInfo.png"] forState:UIControlStateNormal];
    
    [nameButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    nameButton.center =  CGPointMake(nameButton.frame.origin.x + 34, 44);// for vertically center
    [nameButton addTarget:self action:@selector(name_Button_Action) forControlEvents:UIControlEventTouchUpInside];
    
    [buttonView addSubview:nameButton];
    
    
    cutButton = [[UIButton alloc]initWithFrame:CGRectMake(2 * self.navigationController.view.frame.size.width/4 + 10, 0, 50, 50)];
    [cutButton setImage:[UIImage imageNamed:@"Cut.png"] forState:UIControlStateNormal];
    [cutButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    cutButton.center =  CGPointMake(cutButton.frame.origin.x + 34 , 44);// for vertically center
    
    [cutButton addTarget:self action:@selector(cut_Button_Action) forControlEvents:UIControlEventTouchUpInside];
    [buttonView addSubview:cutButton];
    
    beepButton = [[UIButton alloc]initWithFrame:CGRectMake(3 * self.navigationController.view.frame.size.width/4 + 10, 0, 50, 50)];
    [beepButton setImage:[UIImage imageNamed:@"Beep.png"] forState:UIControlStateNormal];
    [beepButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    beepButton.center =  CGPointMake(beepButton.frame.origin.x + 34 , 44);// for vertically center
    
    [beepButton addTarget:self action:@selector(beep_Button_Action) forControlEvents:UIControlEventTouchUpInside];
    [buttonView addSubview:beepButton];
    
    [self.navigationController.view addSubview:buttonView];
}


- (void)gobackHomeToScreen
{
    [[self.navigationController.view viewWithTag:20002]removeFromSuperview];
    if(printer.iPAddress)
    {
        [wiredManager disconnectPrinter: printer];
        [printerListViewController setConnectedIP:YES];
        printer = nil;
        [printerListViewController setConnectedPrinter:printer];
    }else if (printer.bluetoothAccessory.isConnected)
    {
        [bluetoothManager disconnectPrinter:printer];
        printer = nil;
    }
    
    [self.navigationController popToRootViewControllerAnimated:NO];
}


#pragma mark - Button action for info, name & Cut

- (void)info_Button_Action{
    
    isInfo = YES;
    isName = NO;
    
    //    posPrinter = (SAM4SPrintIO *)printer.printIO;
    [posPrinter PrinterSetup];
    
    [posPrinter getPrinterFirmware];
    [printer.printIO.connection setDelegate: self];
    
    [posPrinter getPrinterManufacturer];
    [printer.printIO.connection setDelegate: self];
    
    [posPrinter getPrinterFont];
    [printer.printIO.connection setDelegate: self];
    
    [printer.printIO.connection sendDataToPrinter:[posPrinter getDataTosend:posPrinter]];
    [NSThread sleepForTimeInterval:1.5];
    
}

- (void)name_Button_Action{
    
    isInfo = NO;
    
    
    if(printer.iPAddress)
    {
        isName = YES;
        [posPrinter PrinterSetup];
        [posPrinter getPrinterName];
        [printer.printIO.connection setDelegate: self];
        [printer.printIO.connection sendDataToPrinter:[posPrinter getDataTosend:posPrinter]];
        [NSThread sleepForTimeInterval:1];
        
    }
    else if(printer.bluetoothAccessory.isConnected)
    {
        UIAlertView * alert1 = [[UIAlertView alloc]
                                initWithTitle: @"Printer Name"
                                message: printer.bluetoothAccessory.name
                                delegate: nil
                                cancelButtonTitle: @"OK" otherButtonTitles: nil];
        [alert1 show];
    }
    
}


- (void)cut_Button_Action{
    
    UIAlertView * alert1 = [[UIAlertView alloc]
                            initWithTitle: @"CUT OPTIONS:"
                            message:@""
                            delegate: self
                            cancelButtonTitle:@"CANCEL" otherButtonTitles:@"CUT_FEED",@"CUT_NO_FEED", nil];
    alert1.backgroundColor = [UIColor colorWithRed:85.0/255.0 green:143.0/255.0 blue:220.0/255.0 alpha:1.0];
    [alert1 show];
    
}


- (void)beep_Button_Action
{
    [posPrinter PrinterSetup];
    [posPrinter addTone];
    [printer.printIO.connection sendDataToPrinter:[posPrinter getDataTosend:posPrinter]];
}

#pragma mark - Alert view Delegates

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    [posPrinter PrinterSetup];
    
    if([[alertView buttonTitleAtIndex:buttonIndex] isEqualToString:@"CUT_FEED"]){
        [posPrinter addCut:CUT_FEED];
        [printer.printIO.connection sendDataToPrinter:[posPrinter getDataTosend:posPrinter]];
        
    }else if([[alertView buttonTitleAtIndex:buttonIndex] isEqualToString:@"CUT_NO_FEED"]){
        [posPrinter addCut:CUT_NO_FEED];
        [printer.printIO.connection sendDataToPrinter:[posPrinter getDataTosend:posPrinter]];
        
    }else{
        
    }
    
}


#pragma mark - Table view data source & delegates

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [printMenuArray count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"CellID";
    
    UITableViewCell *cell = (UITableViewCell *)[self.tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    
    if(!cell)
    {
        cell = [[UITableViewCell alloc] initWithStyle: UITableViewCellStyleDefault reuseIdentifier: CellIdentifier];
    }
    
    cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    cell.imageView.image = [UIImage imageNamed:[printMenuImagesArray objectAtIndex:indexPath.row]];
    cell.textLabel.text = [printMenuArray objectAtIndex:indexPath.row];
    
    return cell;
}


-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 70.0f;
}


- (void) tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath

{
    
    id childViewController = [arrViewControllers objectAtIndex: indexPath.row];
    
    if([childViewController isEqual: [NSNull null]])
    {
        NSString *viewControllerClassName = [viewControllerClass objectAtIndex: indexPath.row];
        
        childViewController = [[NSClassFromString(viewControllerClassName) alloc] init];
        
        NSAssert((childViewController != nil), @"Class named <%@> does not exist.", viewControllerClassName);
        
        [childViewController setTitle: [printMenuArray objectAtIndex: indexPath.row]];
        [arrViewControllers replaceObjectAtIndex: indexPath.row withObject: childViewController];
        
        
    }
    
    [[self.navigationController.view viewWithTag:20002]removeFromSuperview];
    //    if(printer.bluetoothAccessory.isConnected)
    //        self.title = printer.bluetoothAccessory.name;
    //    else if (printer.iPAddress)
    //        self.title = printer.bluetoothAccessory.name;
    
    //pass the printer reference to the view controllers
    if([childViewController respondsToSelector: @selector(setPrinter:)])
    {
        [childViewController setPrinter: printer];
        //        self.title = printerName.text;
        self.navigationController.navigationBar.topItem.title = printerName.text;
    }
    [self.navigationController pushViewController: childViewController animated:NO];
    
    
}


-(void) didReceivedDataFromPrinter:(NSData*) data
{
    UIAlertView *alert;
    NSMutableString *receivedDataString;
    if(!receivedDataString)
    {
        receivedDataString = [[NSMutableString alloc] initWithData:data encoding:NSUTF8StringEncoding];
    }
    if(isInfo)
    {
        for (int i=0; i < [receivedDataString length]; i++) {
            NSString *ichar  = [NSString stringWithFormat:@"%c", [receivedDataString characterAtIndex:i]];
            [printerInfoArray addObject:ichar];
        }
        
        NSString *newDataString = @"";
        for(int j = 0; j < [printerInfoArray count]; j++){
            
            newDataString = [newDataString stringByAppendingString:[printerInfoArray objectAtIndex:j]];
        }
        NSArray *receivedArray = [newDataString componentsSeparatedByString:@"_"];
        
        if(printer.bluetoothAccessory.isConnected)
        {
            [printerInfo setObject:printer.bluetoothAccessory.firmwareRevision forKey:@"Firmware"];
            [printerInfo setObject:printer.bluetoothAccessory.manufacturer forKey:@"Manufacturer"];
            if([receivedArray count] == 3)
            {
                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:1] forKey:@"Font"];
                
            }
            alert = [[UIAlertView alloc]initWithTitle: @"Printer Information"
                                              message: [NSString stringWithFormat:@"Firmware:%@\n Manufacturer:%@\n Font:_%@",[printerInfo valueForKey:@"Firmware"],[printerInfo valueForKey:@"Manufacturer"],[printerInfo valueForKey:@"Font"]]
                                             delegate: nil
                                    cancelButtonTitle: @"OK"
                                    otherButtonTitles: nil];
            
        }else if(printer.iPAddress)
        {
            if([receivedArray count] == 4)
            {
                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:1] forKey:@"Firmware"];
                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:2] forKey:@"Manufacturer"];
                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:3] forKey:@"Font"];
                
            }
            //        else if([receivedArray count] == 3)
            //        {
            //            if([[receivedArray objectAtIndex:0] length] == 0)
            //            {
            //                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:1] forKey:@"Firmware"];
            //                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:2] forKey:@"Manufacturer"];
            //                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:2] forKey:@"Font"];
            //
            //            }else if([[receivedArray objectAtIndex:2] length] == 0)
            //            {
            //                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:0] forKey:@"Firmware"];
            //                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:1] forKey:@"Manufacturer"];
            //                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:2] forKey:@"Font"];
            //
            //            }
            //            else{
            //            [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:0] forKey:@"Firmware"];
            //            [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:1] forKey:@"Manufacturer"];
            //            [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:2] forKey:@"Font"];
            //            }
            //
            //        }
            //        else if([receivedArray count] == 2){
            //            if([[receivedArray objectAtIndex:0] length] == 0 && [[receivedArray objectAtIndex:1] length] == 0){
            //
            //            }
            //            else if([[receivedArray objectAtIndex:0] length] == 0)
            //            {
            //                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:1] forKey:@"Firmware"];
            //            }else if([[receivedArray objectAtIndex:1] length] == 0)
            //            {
            //                [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:0] forKey:@"Firmware"];
            //            }else{
            //             [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:0] forKey:@"Firmware"];
            //            [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:1] forKey:@"Manufacturer"];
            //            }
            //        }
            //        else if([receivedArray count] == 1){
            //            [printerInfo setObject:[[newDataString componentsSeparatedByString:@"_"] objectAtIndex:0] forKey:@"Font"];
            //        }
            alert = [[UIAlertView alloc]initWithTitle: @"Printer Information"
                                              message: [NSString stringWithFormat:@"Firmware:_%@\n Manufacturer:_%@\n Font:_%@",[printerInfo valueForKey:@"Firmware"],[printerInfo valueForKey:@"Manufacturer"],[printerInfo valueForKey:@"Font"]]
                                             delegate: nil
                                    cancelButtonTitle: @"OK"
                                    otherButtonTitles: nil];
            
        }
        [printerInfoArray removeAllObjects];
        [printerInfo removeAllObjects];
        [alert show];
        //        isInfo = NO;
    }
    else if(isName)
    {
        alert = [[UIAlertView alloc]
                 initWithTitle: @"Printer Name"
                 message: receivedDataString
                 delegate: nil
                 cancelButtonTitle: @"OK" otherButtonTitles: nil];
        [alert show];
        //        isName = NO;
        
    }
    
    receivedDataString = nil;
}


- (void) disconnectPrinter
{
    //disconnect printer
    [[ConnectionManager sharedBluetooothConnectionManager] disconnectPrinter:printer];
    
    //go back in the navigation hierarchy
    [self gobackHomeToScreen];
}

- (void) didPrinterDisconnected: (Printer*)_printer
{
    if([printer isEqual: _printer])
    {
        printer = nil;
        
        [self gobackHomeToScreen];
    }
}

- (void) disconnectionHandler {
    [[self.navigationController.view viewWithTag:20002]removeFromSuperview];
    if(printer.bluetoothAccessory.isConnected){
        [printerListViewController didPrinterDisconnected:[printerListViewController getConnectedPrinter]];
    }
    if(printer.iPAddress){
        [printerListViewController didPrinterDisconnected:printer];
    }
    [self.navigationController popToRootViewControllerAnimated:NO];
}
- (NSNumber *)pingResult:(NSNumber*)success
{
    static int count  = 0;
    if (success.boolValue)
    {
        count = 0;
    }else if(!success.boolValue)
    {    //only if 5 times ping fails
        
        if (count < 5) {
            [SimplePingHelper ping:printer.iPAddress
                            target:self sel:@selector(pingResult:)];
            count = count + 1;
        }else{
            count = 0;
            [printerListViewController didPrinterDisconnected:printer];
            
        }
    }
    
    return success;
}

@end

