//
//  TwoDCodeViewController.m
//  SHC
//
//  Created by Ambiga on 18/05/15.
//  Copyright (c) 2015 Ambiga. All rights reserved.
//

#import "TwoDCodeViewController.h"
#define TREBUCHET_MS @"Trebuchet MS"


@interface TwoDCodeViewController ()
{
    NSMutableArray * mArrayType;
    
    NSMutableArray * mArrayXs;
    NSMutableArray * mArrayYs;
    NSMutableArray * mArraySize;
    
    int nSelectedType;
    int nSelectedLevel;
    NSString * nSelectedWidth;
    NSString * nSelectedHeight;
    NSString * nSelectedMax;
    int nExistingSelectedIndex;
    //UI to show and hide number pad for text fields
    UIToolbar *toolBar;
    UIBarButtonItem *barItemHideNumPad, *barItemClearText;
}

@property (nonatomic, strong) NSMutableArray * mArrayStdLevel;
@property (nonatomic, strong) UIPickerView * pickerCorrectionLevel;

@end

@implementation TwoDCodeViewController

@synthesize printer;
@synthesize mArrayStdLevel;
@synthesize pickerCorrectionLevel;

- (void)loadView
{
    [super loadView];
    self.navigationController.toolbarHidden = YES ;
    if ([self respondsToSelector:@selector(edgesForExtendedLayout)]) {
        self.edgesForExtendedLayout = UIRectEdgeNone;
        self.extendedLayoutIncludesOpaqueBars = NO;
        self.automaticallyAdjustsScrollViewInsets = NO;
    }
    
    scrollview=[[UIScrollView alloc]initWithFrame:self.view.bounds];;
    scrollview.showsVerticalScrollIndicator=YES;
    [scrollview setBackgroundColor:[UIColor whiteColor]];
    scrollview.scrollEnabled=YES;
    scrollview.userInteractionEnabled=YES;
    CGSize scrollViewContentSize = CGSizeMake(320,890);
    [scrollview setContentSize:scrollViewContentSize];
    [scrollview setDelegate:self];
    [self.view addSubview:scrollview];
    
    UILabel *printCharacters = [[UILabel alloc]initWithFrame:CGRectMake(self.view.frame.origin.x + 20, self.view.frame.origin.y + 5, 200,30)];
    [printCharacters setText:@"Data"];
    [printCharacters setTextAlignment: NSTextAlignmentLeft];
    [printCharacters setBackgroundColor:[UIColor clearColor]];
    [printCharacters setTextColor: [UIColor blackColor]];
//    if([[UIDevice currentDevice].model containsString:@"iPhone"])
    if([UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPhone)
        [printCharacters setFont:[UIFont fontWithName: @"Trebuchet MS" size: 18]];
    else
        [printCharacters setFont:[UIFont fontWithName: @"Trebuchet MS" size: 20]];
    [scrollview addSubview:printCharacters];

    //Textview to type the command
    commandText = [[UITextView alloc]initWithFrame:CGRectMake(self.view.frame.origin.x + 20, self.view.frame.origin.y + 5 + printCharacters.frame.size.height, self.view.frame.size.width - 40, self.view.frame.size.height/5)];
    commandText.layer.borderColor = [UIColor darkGrayColor].CGColor;
    commandText.layer.cornerRadius = 5;
    commandText.font = [UIFont systemFontOfSize:18];
    commandText.layer.borderWidth = 1;
    commandText.text = @"ABCDE";
    commandText.textColor = [UIColor blackColor];
    commandText.returnKeyType = UIReturnKeyDefault;
    [scrollview addSubview:commandText];
    
//    if([[UIDevice currentDevice].model containsString:@"iPhone"])
    if([UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPhone)
    {
        typeLabel = [[UILabel alloc]initWithFrame:CGRectMake(self.view.frame.origin.x + 20, commandText.frame.size.height + 40, 200, 20)];
        moduleSize = [[UILabel alloc]initWithFrame:CGRectMake(self.view.frame.origin.x + 20, typeLabel.frame.origin.y + typeLabel.frame.size.height + 190, 100, 15)];
        printButton = [[UIButton alloc]initWithFrame: CGRectMake(((self.view.frame.size.width - (self.view.frame.size.width/2)) /2), scrollview.frame.origin.y + scrollview.frame.size.height + 20 , self.view.frame.size.width /2, 50)];
    }
    else
    {
        typeLabel = [[UILabel alloc]initWithFrame:CGRectMake(self.view.frame.origin.x + 20, commandText.frame.size.height + 40, 200, 20)];
        moduleSize = [[UILabel alloc]initWithFrame:CGRectMake(self.view.frame.origin.x + 20, typeLabel.frame.origin.y + typeLabel.frame.size.height + 190, 100, 15)];
        printButton = [[UIButton alloc]initWithFrame: CGRectMake(((self.view.frame.size.width - (self.view.frame.size.width/2)) /2), self.view.frame.origin.y + self.view.frame.size.height - 134, self.view.frame.size.width /2, 50)];
    }
    
//    typeLabel.text = @"Error Information";
//    [scrollview addSubview:typeLabel];
    
    
    moduleSize.text = @"Module Size";
    //    [scrollview addSubview:moduleSize];
    
    
    [printButton setTitle:@"Print" forState:UIControlStateNormal];
    printButton.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
    printButton.backgroundColor = [UIColor colorWithRed:85.0/255.0 green:143.0/255.0 blue:220.0/255.0 alpha:1.0];
    [printButton addTarget:self action:@selector(sendCommandToPrinter) forControlEvents:UIControlEventTouchUpInside];
    [scrollview addSubview:printButton];
    
    commandText.delegate = self;
    
}


- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.view.backgroundColor = [UIColor groupTableViewBackgroundColor];
    nExistingSelectedIndex = -1;
    [self updatePickerComponentWithBool:NO];
}

- (void) loadToolbar
{
    NSDictionary *attributes = [NSDictionary dictionaryWithObjectsAndKeys:
                                [UIFont fontWithName: TREBUCHET_MS size: 18], NSFontAttributeName,
                                [UIColor darkGrayColor], NSForegroundColorAttributeName,
                                nil];
    
    //toolbar
    UIBarButtonItem *barItemSpace = [[UIBarButtonItem alloc]
                                     initWithBarButtonSystemItem: UIBarButtonSystemItemFlexibleSpace
                                     target: nil
                                     action: nil];
    
    barItemHideNumPad = [[UIBarButtonItem alloc]
                         initWithTitle: @"Done"
                         style: UIBarButtonItemStyleDone
                         target: self
                         action: nil];
    [barItemHideNumPad setTitleTextAttributes: attributes forState: UIControlStateNormal];
    
    barItemClearText = [[UIBarButtonItem alloc]
                        initWithTitle: @"Clear"
                        style: UIBarButtonItemStyleDone
                        target: self
                        action: nil];
    [barItemClearText setTitleTextAttributes: attributes forState: UIControlStateNormal];
    
    const float heightToolbar = 40.0f;
    toolBar = [[UIToolbar alloc] initWithFrame:
               CGRectMake(0, 0, self.view.frame.size.width, heightToolbar)];
    [toolBar setItems: [NSArray arrayWithObjects:
                        barItemHideNumPad, barItemSpace,
                        barItemClearText, nil]];
}
-(void) updatePickerComponentWithBool:(BOOL) iSUpdateRequired
{
    
    if(!iSUpdateRequired)
    {
        mArrayType = [[NSMutableArray alloc] initWithArray:[NSArray arrayWithObjects:@"STANDARD", @"QR Code Model1", nil]];
        self.mArrayStdLevel = [[NSMutableArray alloc] initWithArray:[NSArray arrayWithObjects:@"LEVEL_0", @"LEVEL_1", @"LEVEL_2", @"LEVEL_3", @"LEVEL_4", @"LEVEL_5", @"LEVEL_6", @"LEVEL_7", @"LEVEL_8", nil]];
        
        mArrayXs = [[NSMutableArray alloc] init];
        mArrayYs = [[NSMutableArray alloc] init];
        mArraySize = [[NSMutableArray alloc] init];
        
        for (int i = 2; i <= 8; i++)
        {
            [mArrayXs addObject:[NSString stringWithFormat:@"%d", i]];
            [mArrayYs addObject:[NSString stringWithFormat:@"%d", i]];
        }
        
        for (int i = 1; i <= 16; i++)
        {
            [mArraySize addObject:[NSString stringWithFormat:@"%d", i]];
        }
//        self.view.frame.origin.x + 20, commandText.frame.size.height + 85, self.view.frame.size.width/4 - 15, 100
        CGRect rect = CGRectMake(self.view.frame.origin.x + 20 , commandText.frame.size.height + 75, self.view.frame.size.width/3.5, 100);
        rect.size.width = self.view.frame.size.width/2.35;
        //        rect.origin.x += 10;
        
        for (int i = 0; i <= 4; i++)
        {
            UIPickerView * pickerView =  [[UIPickerView alloc]initWithFrame:rect];
            pickerView.delegate = self;
            pickerView.dataSource = self;
            pickerView.tag = i;
            [pickerView.layer setBorderColor: [UIColor darkGrayColor].CGColor];
            [pickerView.layer setBorderWidth: 1.0f];
            [pickerView.layer setCornerRadius: 5.0f];
            [scrollview addSubview:pickerView];
            
            UILabel *label = [[UILabel alloc] initWithFrame: CGRectMake(pickerView.frame.origin.x, pickerView.frame.origin.y - 27, pickerView.frame.size.width, 22)];
            NSString * string = nil;
            switch (i) {
                    
                case 0:
                    string = @"Type";
                    [pickerView selectRow:0 inComponent:0 animated:YES];
                    nSelectedType = (int)[pickerView selectedRowInComponent:0];
                    break;
                    
                case 1:
                    string = @"Correction";
                    self.pickerCorrectionLevel = pickerView;
                    [pickerView selectRow:0 inComponent:0 animated:YES];
                    nSelectedLevel = (int)[pickerView selectedRowInComponent:0];
                    break;
                    
                case 2:
                    string = @"Width";
                    [pickerView selectRow:1 inComponent:0 animated:YES];
                    nSelectedWidth = [mArrayXs objectAtIndex:1];
                    break;
                    
                case 3:
                    string = @"Height";
                    [pickerView selectRow:1 inComponent:0 animated:YES];
                    nSelectedHeight = [mArrayYs objectAtIndex:1];
                    break;
                    
                case 4:
                    string = @"Max";
                    [pickerView selectRow:2 inComponent:0 animated:YES];
                    nSelectedMax = [mArraySize objectAtIndex:2];
                    break;
                    
                default:
                    break;
            }
            
            [label setText:string];
//            if([[UIDevice currentDevice].model containsString:@"iPhone"])
            if([UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPhone)
            [label setFont:[UIFont fontWithName: @"Trebuchet MS" size: 18]];
            else
            [label setFont:[UIFont fontWithName: @"Trebuchet MS" size: 20]];
            [label setTextAlignment: NSTextAlignmentCenter];
            [label setBackgroundColor:[UIColor clearColor]];
            [label setTextColor: [UIColor blackColor]];
            [scrollview addSubview:label];
            rect.origin.x += rect.size.width + 25;
            
            if(i == 1)
            {
//                if([[UIDevice currentDevice].model containsString:@"iPhone"])
                if([UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPhone)
                {
                    rect.origin.y += commandText.frame.size.height + 95;
                    
                }else
                {
                    rect.origin.y += commandText.frame.size.height + 10;
                    
                }
                rect.origin.x = self.view.frame.origin.x + 20;
                rect.size.width = self.view.frame.size.width/3 - 20;
            }
            
            if(i == 2 || i == 3)
            {
                
                rect.origin.x -= 15;
            }
        }
    }else
    {
        self.pickerCorrectionLevel = (UIPickerView*)[self.view viewWithTag:1];
        [pickerCorrectionLevel removeFromSuperview];
        [scrollview addSubview:self.pickerCorrectionLevel];
        [self.pickerCorrectionLevel reloadAllComponents];
    }
    
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:YES];
    self.navigationController.toolbarHidden = YES ;
    [self.view endEditing:YES];
    commandText.text = @"ABCDE";
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:YES];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - UIScrollViewDelegate
- (void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    [self changeScrollBarColorFor:scrollView];
}

- (void)changeScrollBarColorFor:(UIScrollView *)scrollView
{
    for ( UIView *view in scrollView.subviews ) {
        
        if (view.tag == 0 && [view isKindOfClass:UIImageView.class])
        {
            
            UIImageView *imageView = (UIImageView *)view;
            imageView.backgroundColor = [UIColor colorWithRed:85.0/255.0 green:143.0/255.0 blue:220.0/255.0 alpha:1.0];
        }
    }
}

#pragma mark - Text View View Delegates
- (BOOL) textViewShouldBeginEditing:(UITextView *)textView
{
    if(commandText)
    {
        if(!toolBar)
        {
            [self loadToolbar];
        }
        
        [barItemHideNumPad setTarget: textView];
        [barItemHideNumPad setAction: @selector(resignFirstResponder)];
        
        [barItemClearText setTarget: self];
        [barItemClearText setAction:@selector(clearText)];
        
        [textView setInputAccessoryView: toolBar];
    }
    
    return YES;
}

- (void) clearText
{
    commandText.text = nil;
    
}
- (void)textViewDidBeginEditing:(UITextView *)textView
{
    //Implementation not required
}


- (void)textViewDidEndEditing:(UITextView *)textView{
    commandText.text = textView.text ;
}


- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range
 replacementText:(NSString *)text
{
    // Any new character added is passed in as the "text" parameter
    if ([text isEqualToString:@"\n"]) {
        // Be sure to test for equality using the "isEqualToString" message
        // [textView resignFirstResponder];
//        commandText.text = [NSString stringWithFormat:@"%@\n",commandText.text];
        [commandText insertText:text];
        // Return FALSE so that the final '\n' character doesn't get added
        return FALSE;
    }
    // For any other character return TRUE so that the text gets added to the view
    return TRUE;
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    [self.view endEditing:YES];
    [scrollview endEditing:YES];
    [super touchesBegan:touches withEvent:event];
}
#pragma mark - Picker View Delegates
//PickerView delegate
- (UIView*) pickerView: (UIPickerView*)pickerView viewForRow: (NSInteger)row forComponent: (NSInteger)component reusingView: (UIView*)view
{
    NSString *pickerText = nil;
    
    switch (pickerView.tag)
    {
        case 0:
            pickerText = [mArrayType objectAtIndex:row];
            break;
            
        case 1:
            pickerText = [mArrayStdLevel objectAtIndex:row];
            
            break;
            
        case 2:
            pickerText = [mArrayXs objectAtIndex:row];
            break;
            
        case 3:
            pickerText = [mArrayYs objectAtIndex:row];
            break;
            
        case 4:
            pickerText = [mArraySize objectAtIndex:row];
            break;
            
        default:
            break;
    }
    
    
    UILabel *label = [[UILabel alloc] initWithFrame: CGRectMake(0, 0, widthPicker, 40)];
    [label setText: pickerText];
    [label setFont: fontPickerText];
    [label setTextAlignment: NSTextAlignmentCenter];
    [label setTextColor: [UIColor blackColor]];
    
    return  label;
    
}

- (NSInteger) pickerView: (UIPickerView*)pickerView numberOfRowsInComponent: (NSInteger)component
{
    NSInteger numRows = 0;
    switch (pickerView.tag)
    {
        case 0:
            numRows = [mArrayType count];
            break;
            
        case 1:
            numRows = [mArrayStdLevel count];
            break;
            
        case 2:
            numRows = [mArrayXs count];
            break;
            
        case 3:
            numRows = [mArrayYs count];
            break;
            
        case 4:
            numRows = [mArraySize count];
            break;
            
        default:
            break;
    }
    
    return numRows;
}


- (NSInteger) numberOfComponentsInPickerView: (UIPickerView *)pickerView
{
    return 1;
}


- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component
{
    switch (pickerView.tag)
    {
        case 0:
        {
            if(nExistingSelectedIndex != row)
            {
                if(row == 1)
                {
                    [mArrayStdLevel removeAllObjects];
                    self.mArrayStdLevel = [[NSMutableArray alloc] initWithArray:[NSArray arrayWithObjects:@"LEVEL_L", @"LEVEL_M", @"LEVEL_Q", @"LEVEL_H", nil]];
                }
                else
                {
                    [mArrayStdLevel removeAllObjects];
                    self.mArrayStdLevel = [[NSMutableArray alloc] initWithArray:[NSArray arrayWithObjects:@"LEVEL_0", @"LEVEL_1", @"LEVEL_2", @"LEVEL_3", @"LEVEL_4", @"LEVEL_5", @"LEVEL_6", @"LEVEL_7", @"LEVEL_8", nil]];
                }
                nExistingSelectedIndex = (int)row;
                [self updatePickerComponentWithBool:YES];
            }
            nSelectedType = (int)[pickerView selectedRowInComponent:0];
        }
            break;
            
        case 1:
            nSelectedLevel = (int)[pickerView selectedRowInComponent:0];
            break;
            
        case 2:
            nSelectedWidth = [mArrayXs objectAtIndex:row];
            break;
            
        case 3:
            nSelectedHeight = [mArrayYs objectAtIndex:row];
            break;
            
        case 4:
            nSelectedMax = [mArraySize objectAtIndex:row];
            break;
            
        default:
            break;
    }
    
}

- (void)sendCommandToPrinter{
    
    if(printer){
        
        SAM4SPrintIO *sam4sIO = (SAM4SPrintIO *)printer.printIO;
        printer.printIO.connection.delegate = self;
        [sam4sIO PrinterSetup];
        if(nSelectedType == STANDARD)
        {
            [sam4sIO addPDF417Symbol :[commandText.text dataUsingEncoding:NSUTF8StringEncoding] :nSelectedType :nSelectedLevel :[nSelectedWidth intValue] :[nSelectedHeight  intValue]];
        }
        else if (nSelectedType == QR_CODE_MODEL1)
        {
            [sam4sIO addQRCodeSymbol:[commandText.text dataUsingEncoding:NSUTF8StringEncoding] :nSelectedType :nSelectedLevel :[nSelectedMax intValue]];
        }
        
        [printer.printIO.connection sendDataToPrinter:[sam4sIO getDataTosend:sam4sIO]];
    }
}

-(void)didReceivedDataFromPrinter:(NSData *)data
{
    NSMutableArray *printerInfoArray;
    if (!printerInfoArray) {
        printerInfoArray = [[NSMutableArray alloc]init];
    }
    NSMutableString *receivedDataString = [[NSMutableString alloc] initWithData:data encoding:NSUTF8StringEncoding];

    for (int i=0; i < [receivedDataString length]; i++) {
//    NSString *ichar  = [NSString stringWithFormat:@"%c", [receivedDataString characterAtIndex:i]];
//    [printerInfoArray addObject:ichar];
//        }
//        
//        NSString *newDataString = @"";
//        for(int j = 0; j < [printerInfoArray count]; j++){
//            
//            newDataString = [newDataString stringByAppendingString:[printerInfoArray objectAtIndex:j]];
        }
//        NSArray *receivedArray = [newDataString componentsSeparatedByString:@"_"];
}
@end
